#include <Xm/LabelG.h>
#include <Xm/Text.h>
#include <stdio.h>
#include <math.h>
#include "global.h"

#include <time.h>

void showtime(int offset) {
  /* offset = 0 : reset timer to zero            */
  /* offset = 1 : show duration of recording     */
  /* offset = 2 : stop timer                     */
  /* offset = 3 : continue timer                 */
  /* offset = 4 : show recording duration anyway */
  char     mess[255];
           int     t_std, t_min, t_sec;
  static   time_t  before_zeit, stop_zeit;
  unsigned long    delta_zeit;
           int     i, j;
	   float   wert, b, m;

  switch(offset) {
  case 0:  // reset timer to zero;
    initial_zeit=time(NULL);
    before_zeit=-2*(UPDATE_TIMER);
    break;
  case 1:  // show duration of recording;
    delta_zeit=(unsigned long) (time(NULL)-initial_zeit);
    if (delta_zeit-before_zeit>=UPDATE_TIMER) {
      if (reg.store) {
	t_std=(int)(floor(delta_zeit/3600));
	t_min=(int)(floor((delta_zeit-t_std*3600)/60));
	t_sec=(int)(delta_zeit-t_std*3600-t_min*60);
	sprintf(mess,"%.2d:%.2d:%.2d", t_std, t_min, t_sec);
	XtVaSetValues(mess_label,
		      XtVaTypedArg, XmNlabelString, XmRString, mess, strlen(mess)+1,
		      NULL);
      }
      if (reg.analog) {
	for (i=0; i<8; i++) {
	  if (ch[i].active) {
	    if (ch[i].analog_n>0) {
	      wert=(float)((float)ch[i].analog_sum/(float)ch[i].analog_n);
	      ch[i].analog_sum=0; ch[i].analog_n=0;
	      m=(ch[i].cal.rw_high-ch[i].cal.rw_low)/(ch[i].cal.ad_high-ch[i].cal.ad_low);
	      b=ch[i].cal.rw_high-(m*ch[i].cal.ad_high);
	      sprintf(mess, "%f", b+m*wert);
	      XmTextSetString(ch[i].analog, mess);
	    }
	  }
	  for (j=0; j<7; j++) {
	    if (dch[i].ch[j].active) {
	      if (dch[i].ch[j].analog_n>0) {
		wert=(float)((float)dch[i].ch[j].analog_sum/(float)dch[i].ch[j].analog_n);
		dch[i].ch[j].analog_sum=0; dch[i].ch[j].analog_n=0;
		m=(dch[i].ch[j].cal.rw_high-dch[i].ch[j].cal.rw_low)/
		  (dch[i].ch[j].cal.ad_high-dch[i].ch[j].cal.ad_low);
		b=dch[i].ch[j].cal.rw_high-(m*dch[i].ch[j].cal.ad_high);
		sprintf(mess, "%f", b+m*wert);
		XmTextSetString(dch[i].ch[j].analog, mess);
	      }
	    }
	  }
	}
      }
      before_zeit=delta_zeit;
    }
    break;
  case 2:   // stop timer;
    stop_zeit=time(NULL);
    break;
  case 3:   // continue timer;
    initial_zeit+=(time(NULL)-stop_zeit);
    before_zeit=initial_zeit;
    break;
  case 4:   // show recording duration anyway;
    delta_zeit=(unsigned long) (time(NULL)-initial_zeit);
    t_std=(int)(floor(delta_zeit/3600));
    t_min=(int)(floor((delta_zeit-t_std*3600)/60));
    t_sec=(int)(delta_zeit-t_std*3600-t_min*60);
    sprintf(mess,"%.2d:%.2d:%.2d", t_std, t_min, t_sec);
    XtVaSetValues(mess_label,
		  XtVaTypedArg, XmNlabelString, XmRString, mess, strlen(mess)+1,
		  NULL);
    before_zeit=delta_zeit;
    break;
  }
}
